/*************************************************************
Motor Shield 2-Channel DC Motor Demo
by Randy Sarafan

For more information see:
https://www.instructables.com/id/Arduino-Motor-Shield-Tutorial/

*************************************************************/
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_LSM9DS1.h>
#include <Adafruit_Sensor.h>  // not used in this demo but required!
#include <DualMC33926MotorShield.h>

DualMC33926MotorShield md;

void stopIfFault()
{
  if (md.getFault())
  {
    Serial.println("fault");
    while(1);
  }
}


// i2c
Adafruit_LSM9DS1 lsm = Adafruit_LSM9DS1();

#define LSM9DS1_SCK A5
#define LSM9DS1_MISO 12
#define LSM9DS1_MOSI A4
#define LSM9DS1_XGCS 6
#define LSM9DS1_MCS 5
// You can also use software SPI
//Adafruit_LSM9DS1 lsm = Adafruit_LSM9DS1(LSM9DS1_SCK, LSM9DS1_MISO, LSM9DS1_MOSI, LSM9DS1_XGCS, LSM9DS1_MCS);
// Or hardware SPI! In this case, only CS pins are passed in
//Adafruit_LSM9DS1 lsm = Adafruit_LSM9DS1(LSM9DS1_XGCS, LSM9DS1_MCS);


int inPin = 5;   // pushbutton connected to digital pin 5
int inPin2 = 6;   // pushbutton connected to digital pin 6

int val1 = 0;         // variable to store the read value
int val2 = 0;         // variable to store the read value
int val3 = 0;         // variable to store the read value
int val4 = 0;         // variable to store the read value
//Max K=400
int k=200;
int k1=k;
int k2=k;

float minute = 0;
int t1 = 0;
int t2 = 0;
int dt = 0;
int rpm = 0;
int count = 0;
int count2 = 0;

void setupSensor()
{
  // 1.) Set the accelerometer range
  lsm.setupAccel(lsm.LSM9DS1_ACCELRANGE_2G);
  //lsm.setupAccel(lsm.LSM9DS1_ACCELRANGE_4G);
  //lsm.setupAccel(lsm.LSM9DS1_ACCELRANGE_8G);
  //lsm.setupAccel(lsm.LSM9DS1_ACCELRANGE_16G);
  
  // 2.) Set the magnetometer sensitivity
  lsm.setupMag(lsm.LSM9DS1_MAGGAIN_4GAUSS);
  //lsm.setupMag(lsm.LSM9DS1_MAGGAIN_8GAUSS);
  //lsm.setupMag(lsm.LSM9DS1_MAGGAIN_12GAUSS);
  //lsm.setupMag(lsm.LSM9DS1_MAGGAIN_16GAUSS);

  // 3.) Setup the gyroscope
  lsm.setupGyro(lsm.LSM9DS1_GYROSCALE_245DPS);
  //lsm.setupGyro(lsm.LSM9DS1_GYROSCALE_500DPS);
  //lsm.setupGyro(lsm.LSM9DS1_GYROSCALE_2000DPS);
}

void setup() {

  //Set up Motor Controller
  Serial.begin(9600);

  md.init(); 

  pinMode(inPin, INPUT);      // sets the digital pin 7 as input
  pinMode(inPin2, INPUT);      // sets the digital pin 7 as input
  
  t1=millis();
  //Set up IMU
  
  while (!Serial) {
    delay(1); // will pause Zero, Leonardo, etc until serial console opens
  }
  
  //Serial.println("Test Rover 1:");
  
  // Try to initialise and warn if we couldn't detect the chip
  if (!lsm.begin())
  {
    Serial.println("Oops ... unable to initialize the LSM9DS1. Check your wiring!");
    while (1);
  }
  //Serial.println("Found LSM9DS1 9DOF");

  // helper to just set the default scaling we want, see above!
  setupSensor();
}




void loop(){

  //Motor A forward 
  md.setM1Speed(k1);
  stopIfFault();

  //Motor B backward 
  md.setM2Speed(-k2);
  stopIfFault();


 
  //Encoders
  val1 = digitalRead(inPin);   // read the input pin
  val3 = digitalRead(inPin2);   // read the input pin

  //Ensures Motors are Same Speed
  //if (val1>val3) {
    //k2=k2+1;
  //}
  //else if (val1<val3) {
    //k2=k2-1;
  //}
  //else {
    //k2=k1;
  //}
  
  //Calculates RPM
   if (val1 != val2){
     count=count+1;
     val2 = val1;

    
    //Full count is 1800 for one geared revolution
    if (count == 1800) {
    t2 = millis();
   
    dt = t2-t1;
    t1 = t2;
   
    minute=dt/60000;
  // RPM is 60000/dt for 1800 count or 300 with 10000
      rpm=60000/dt;
      count=0;

   }
  }
  
if (val3 != val4){
     count2=count2+1;
     val4 = val3;

    //Full count is 1800 for one geared revolution
    if (count2 == 1800) {
    t2 = millis();
   
    dt = t2-t1;
    t1 = t2;
   
    minute=dt/60000;
  // RPM is 60000/dt for 1800 count or 300 with 10000
  rpm=60000/dt;
  count2=0;
 
   }
  }

  // Reads and Prints IMU Data
  lsm.read();  /* ask it to read in the data */ 

  /* Get a new sensor event */ 
  sensors_event_t a, m, g, temp;

  lsm.getEvent(&a, &m, &g, &temp); 

 Serial.println(a.acceleration.x);
 Serial.println(a.acceleration.y);   
 Serial.println(a.acceleration.z);   

Serial.println(m.magnetic.x);  
 Serial.println(m.magnetic.y);   
  Serial.println(m.magnetic.z);   

  Serial.println(g.gyro.x); 
 Serial.println(g.gyro.y);     
 Serial.println(g.gyro.z);  

  //delay(2000);
}
